All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
PFile Class Reference

This class represents a disk file. More...

`#include <file.h>`

Inheritance diagram for PFile:

## Public Member Functions

Overrides from class PObject
Comparison | Compare (const PObject &obj) const
| Determine the relative rank of the two objects. More...
Overrides from class PChannel
virtual PString | GetName () const
| Get the platform and I/O channel type name of the channel. More...
virtual PBoolean | Read (void *buf, PINDEX len)
| Low level read from the file channel. More...
virtual PBoolean | Write (const void *buf, PINDEX len)
| Low level write to the file channel. More...
virtual PBoolean | Close ()
| Close the file channel. More...
Public Member Functions inherited from PChannel
PBoolean | SetErrorValues (Errors errorCode, int osError, ErrorGroup group=LastGeneralError)
| Set error values to those specified. More...
| PChannel ()
| Create the channel. More...
| ~PChannel ()
| Close down the channel. More...
virtual PINDEX | HashFunction () const
| Calculate a hash value for use in sets and dictionaries. More...
virtual PBoolean | IsOpen () const
| Determine if the channel is currently open. More...
int | GetHandle () const
| Get the integer operating system handle for the channel. More...
virtual PChannel * | GetBaseReadChannel () const
| Get the base channel of channel indirection using PIndirectChannel. More...
virtual PChannel * | GetBaseWriteChannel () const
| Get the base channel of channel indirection using PIndirectChannel. More...
void | SetReadTimeout (const PTimeInterval &time)
| Set the timeout for read operations. More...
PTimeInterval | GetReadTimeout () const
| Get the timeout for read operations. More...
virtual PINDEX | GetLastReadCount () const
| Get the number of bytes read by the last Read() call. More...
virtual int | ReadChar ()
| Read a single 8 bit byte from the channel. More...
PBoolean | ReadBlock (void *buf, PINDEX len)
| Read len bytes into the buffer from the channel. More...
PString | ReadString (PINDEX len)
| Read `len` character into a string from the channel. More...
virtual PBoolean | ReadAsync (void *buf, PINDEX len)
| Begin an asynchronous read from channel. More...
virtual void | OnReadComplete (void *buf, PINDEX len)
| User callback function for when a `ReadAsync()` call has completed or timed out. More...
void | SetWriteTimeout (const PTimeInterval &time)
| Set the timeout for write operations to complete. More...
PTimeInterval | GetWriteTimeout () const
| Get the timeout for write operations to complete. More...
virtual PBoolean | Write (const void *buf, PINDEX len, const void *mark)
| Low level write to the channel with marker. More...
virtual PINDEX | GetLastWriteCount () const
| Get the number of bytes written by the last Write() call. More...
PBoolean | WriteChar (int c)
| Write a single character to the channel. More...
PBoolean | WriteString (const PString &str)
| Write a string to the channel. More...
virtual PBoolean | WriteAsync (const void *buf, PINDEX len)
| Begin an asynchronous write from channel. More...
virtual void | OnWriteComplete (const void *buf, PINDEX len)
| User callback function for when a WriteAsync() call has completed or timed out. More...
virtual PBoolean | Shutdown (ShutdownValue option)
| Close one or both of the data streams associated with a channel. More...
virtual bool | SetLocalEcho (bool localEcho)
| Set local echo mode. More...
virtual bool | FlowControl (const void *flowData)
| Flow Control information Pass data to the channel for flowControl determination. More...
PBoolean | SetBufferSize (PINDEX newSize)
| Set the iostream buffer size for reads and writes. More...
PBoolean | SendCommandString (const PString &command)
| Send a command meta-string. More...
void | AbortCommandString ()
| Abort a command string that is in progress. More...
Errors | GetErrorCode (ErrorGroup group=NumErrorGroups) const
| Get normalised error code. More...
int | GetErrorNumber (ErrorGroup group=NumErrorGroups) const
| Get OS errro code. More...
virtual PString | GetErrorText (ErrorGroup group=NumErrorGroups) const
| Get error message description. More...
virtual PBoolean | Read (const VectorOfSlice &slices)
| Low level scattered read from the channel. More...
virtual PBoolean | Write (const VectorOfSlice &slices)
| Low level scattered write to the channel. More...
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Attributes

PFilePath | path
| The fully qualified path name for the file. More...
PBoolean | removeOnClose
| File is to be removed when closed. More...
Protected Attributes inherited from PChannel
int | os_handle
| The operating system file handle return by standard open() function. More...
Errors | lastErrorCode [NumErrorGroups+1]
| The platform independant error code. More...
int | lastErrorNumber [NumErrorGroups+1]
| The operating system error number (eg as returned by errno). More...
PINDEX | lastReadCount
| Number of byte last read by the Read() function. More...
PINDEX | lastWriteCount
| Number of byte last written by the Write() function. More...
PTimeInterval | readTimeout
| Timeout for read operations. More...
PTimeInterval | writeTimeout
| Timeout for write operations. More...
PString | channelName
PMutex | px_threadMutex
PXBlockType | px_lastBlockType
PThread * | px_readThread
PThread * | px_writeThread
PMutex | px_writeMutex
PThread * | px_selectThread [3]
PMutex | px_selectMutex [3]

## Construction

enum | OpenMode { ReadOnly, WriteOnly, ReadWrite }
| When a file is opened, it may restrict the access available to operations on the object instance. More...
enum | OpenOptions { ModeDefault = -1, MustExist = 0, Create = 1, Truncate = 2, Exclusive = 4, Temporary = 8, DenySharedRead = 16, DenySharedWrite = 32 }
| When a file is opened, a number of options may be associated with the open file. More...
| PFile ()
| Create a file object but do not open it. More...
| PFile (OpenMode mode, int opts=ModeDefault)
| Create a unique temporary file name, and open the file in the specified mode and using the specified options. More...
| PFile (const PFilePath &name, OpenMode mode=ReadWrite, int opts=ModeDefault)
| Create a file object with the specified name and open it in the specified mode and with the specified options. More...
| ~PFile ()
| Close the file on destruction. More...

## File manipulation functions

PBoolean | Exists () const
| Check for file existance. More...
PBoolean | Access (OpenMode mode)
| Check for file access modes. More...
PBoolean | Remove (PBoolean force=false)
| Delete the current file. More...
PBoolean | Rename (const PString &newname, PBoolean force=false)
| Change the current files name. More...
PBoolean | Copy (const PFilePath &newname, PBoolean force=false)
| Make a copy of the current file. More...
PBoolean | Move (const PFilePath &newname, PBoolean force=false)
| Move the current file. More...
static PBoolean | Exists (const PFilePath &name)
| Check for file existance. More...
static PBoolean | Access (const PFilePath &name, OpenMode mode)
| Check for file access modes. More...
static PBoolean | Remove (const PFilePath &name, PBoolean force=false)
| Delete the specified file. More...
static PBoolean | Remove (const PString &name, PBoolean force=false)
static PBoolean | Rename (const PFilePath &oldname, const PString &newname, PBoolean force=false)
| Change the specified files name. More...
static PBoolean | Copy (const PFilePath &oldname, const PFilePath &newname, PBoolean force=false)
| Make a copy of the specified file. More...
static PBoolean | Move (const PFilePath &oldname, const PFilePath &newname, PBoolean force=false)
| Move the specified file. More...

## File channel functions

enum | FilePositionOrigin { Start = SEEK_SET, Current = SEEK_CUR, End = SEEK_END }
| Options for the origin in setting the file position. More...
const PFilePath & | GetFilePath () const
| Get the full path name of the file. More...
void | SetFilePath (const PString &path)
| Set the full path name of the file. More...
virtual PBoolean | Open (OpenMode mode=ReadWrite, int opts=ModeDefault)
| Open the current file in the specified mode and with the specified options. More...
virtual PBoolean | Open (const PFilePath &name, OpenMode mode=ReadWrite, int opts=ModeDefault)
| Open the specified file name in the specified mode and with the specified options. More...
virtual off_t | GetLength () const
| Get the current size of the file. More...
virtual PBoolean | SetLength (off_t len)
| Set the size of the file, padding with 0 bytes if it would require expanding the file, or truncating it if being made shorter. More...
virtual PBoolean | SetPosition (off_t pos, FilePositionOrigin origin=Start)
| Set the current active position in the file for the next read or write operation. More...
virtual off_t | GetPosition () const
| Get the current active position in the file for the next read or write operation. More...
PBoolean | IsEndOfFile () const
| Determine if the current file position is at the end of the file. More...
PBoolean | GetInfo (PFileInfo &info)
| Get information (eg protection, timestamps) on the current file. More...
PBoolean | SetPermissions (int permissions)
| Set permissions on the current file. More...
static PBoolean | GetInfo (const PFilePath &name, PFileInfo &info)
| Get information (eg protection, timestamps) on the specified file. More...
static PBoolean | SetPermissions (const PFilePath &name, int permissions)
| Set permissions on the specified file. More...

## Additional Inherited Members

Public Types inherited from PChannel
enum | PXBlockType { PXReadBlock, PXWriteBlock, PXAcceptBlock, PXConnectBlock }
enum | ShutdownValue { ShutdownRead = 0, ShutdownWrite = 1, ShutdownReadAndWrite = 2 }
enum | Errors { NoError, NotFound, FileExists, DiskFull, AccessDenied, DeviceInUse, BadParameter, NoMemory, NotOpen, Timeout, Interrupted, BufferTooSmall, Miscellaneous, ProtocolFailure, NumNormalisedErrors }
| Normalised error codes. More...
enum | ErrorGroup { LastReadError, LastWriteError, LastGeneralError, NumErrorGroups }
| Error groups. More...
typedef std::vector< Slice > | VectorOfSlice
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PChannel
static PBoolean | ConvertOSError (int libcReturnValue, Errors &lastError, int &osError)
| Convert an operating system error into platform independent error. More...
static PString | GetErrorText (Errors lastError, int osError=0)
| Get error message description. More...
Static Public Member Functions inherited from PObject
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
static const char * | Class ()
| Get the name of the class as a C string. More...
Protected Member Functions inherited from PChannel
| PChannel (const PChannel &)
PChannel & | operator= (const PChannel &)
virtual PBoolean | ConvertOSError (int libcReturnValue, ErrorGroup group=LastGeneralError)
| Convert an operating system error into platform independent error. More...
int | ReadCharWithTimeout (PTimeInterval &timeout)
| Read a character with specified timeout. More...
PBoolean | ReceiveCommandString (int nextChar, const PString &reply, PINDEX &pos, PINDEX start)
PBoolean | PXSetIOBlock (PXBlockType type, const PTimeInterval &timeout)
int | PXClose ()
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Detailed Description

This class represents a disk file.

This is a particular type of I/O channel that has certain attributes. All platforms have a disk file, though exact details of naming convertions etc may be different.

The basic model for files is that they are a named sequence of bytes that persists within a directory structure. The transfer of data to and from the file is made at a current position in the file. This may be set to random locations within the file.

## Member Enumeration Documentation

enum PFile::FilePositionOrigin

Options for the origin in setting the file position.

Enumerator
Start | Set position relative to start of file.
Current | Set position relative to current file position.
End | Set position relative to end of file.

enum PFile::OpenMode

When a file is opened, it may restrict the access available to operations on the object instance.

A value from this enum is passed to the `Open()` function to set the mode.

Enumerator
ReadOnly | File can be read but not written.
WriteOnly | File can be written but not read.
ReadWrite | File can be both read and written.

enum PFile::OpenOptions

When a file is opened, a number of options may be associated with the open file.

These describe what action to take on opening the file and what to do on closure. A value from this enum is passed to the `Open()` function to set the options.

The `ModeDefault` option will use the following values:

- `ReadOnly` `MustExist`
- `WriteOnly` `Create | Truncate`
- `ReadWrite` `Create`

Enumerator
ModeDefault | File options depend on the OpenMode parameter.
MustExist | File open fails if file does not exist.
Create | File is created if it does not exist.
Truncate | File is set to zero length if it already exists.
Exclusive | File open fails if file already exists.
Temporary | File is temporary and is to be deleted when closed.
DenySharedRead | File may not be read by another process.
DenySharedWrite | File may not be written by another process.

## Constructor & Destructor Documentation

PFile::PFile | ( |  | ) |

Create a file object but do not open it.

It does not initially have a valid file name. However, an attempt to open the file using the `Open()` function will generate a unique temporary file.

PFile::PFile | ( | OpenMode | mode,
|  | int | opts = `ModeDefault`
| ) |  |

Create a unique temporary file name, and open the file in the specified mode and using the specified options.

Note that opening a new, unique, temporary file name in ReadOnly mode will always fail. This would only be usefull in a mode and options that will create the file.

The `PChannel::IsOpen()` function may be used after object construction to determine if the file was successfully opened.

Parameters

  mode | Mode in which to open the file.
  opts | `OpenOptions` enum# for open operation.

PFile::PFile | ( | const PFilePath & | name,
|  | OpenMode | mode = `ReadWrite`,
|  | int | opts = `ModeDefault`
| ) |  |

Create a file object with the specified name and open it in the specified mode and with the specified options.

The `PChannel::IsOpen()` function may be used after object construction to determine if the file was successfully opened.

Parameters

  name | Name of file to open.
  mode | Mode in which to open the file.
  opts | `OpenOptions` enum# for open operation.

PFile::~PFile | ( |  | ) |

Close the file on destruction.

## Member Function Documentation

static PBoolean PFile::Access | ( | const PFilePath & | name,
|  | OpenMode | mode
| ) |  |

static

Check for file access modes.

Determine if the file specified may be opened in the specified mode. This would check the current access rights to the file for the mode. For example, for a file that is read only, using mode == ReadWrite would return false but mode == ReadOnly would return true.

Returns
  true if a file open would succeed.

Parameters

  name | Name of file to have its access checked.
  mode | Mode in which the file open would be done.

PBoolean PFile::Access | ( | OpenMode | mode | ) |

Check for file access modes.

Determine if the file path specification associated with the instance of the object may be opened in the specified mode. This would check the current access rights to the file for the mode. For example, for a file that is read only, using mode == ReadWrite would return false but mode == ReadOnly would return true.

Returns
  true if a file open would succeed.

Parameters

  mode | Mode in which the file open would be done.

virtual PBoolean PFile::Close | ( |  | ) |

virtual

Close the file channel.

Returns
  true if close was OK.

Reimplemented from PChannel.

Reimplemented in PWAVFile, and PMemoryFile.

Comparison PFile::Compare | ( | const PObject & | obj | ) | const

virtual

Determine the relative rank of the two objects.

This is essentially the string comparison of the `PFilePath` names of the files.

Returns
  relative rank of the file paths.

Parameters

  obj | Other file to compare against.

Reimplemented from PChannel.

Reimplemented in PMemoryFile.

static PBoolean PFile::Copy | ( | const PFilePath & | oldname,
|  | const PFilePath & | newname,
|  | PBoolean | force = `false`
| ) |  |

static

Make a copy of the specified file.

Returns
  true if the file was renamed.

Parameters

  oldname | Old name of the file.
  newname | New name for the file.
  force | Delete file if a destination exists with the same name.

PBoolean PFile::Copy | ( | const PFilePath & | newname,
|  | PBoolean | force = `false`
| ) |  |

Make a copy of the current file.

Returns
  true if the file was renamed.

Parameters

  newname | New name for the file.
  force | Delete file if a destination exists with the same name.

static PBoolean PFile::Exists | ( | const PFilePath & | name | ) |

static

Check for file existance.

Determine if the file specified actually exists within the platforms file system.

Returns
  true if the file exists.

Parameters

  name | Name of file to see if exists.

PBoolean PFile::Exists | ( |  | ) | const

Check for file existance.

Determine if the file path specification associated with the instance of the object actually exists within the platforms file system.

Returns
  true if the file exists.

const PFilePath& PFile::GetFilePath | ( |  | ) | const

Get the full path name of the file.

The `PFilePath` object describes the full file name specification for the particular platform.

Returns
  the name of the file.

Referenced by PSystemLogToFile::GetFilePath().

static PBoolean PFile::GetInfo | ( | const PFilePath & | name,
|  | PFileInfo & | info
| ) |  |

static

Get information (eg protection, timestamps) on the specified file.

Returns
  true if the file info was retrieved.

PBoolean PFile::GetInfo | ( | PFileInfo & | info | ) |

Get information (eg protection, timestamps) on the current file.

Returns
  true if the file info was retrieved.

virtual off_t PFile::GetLength | ( |  | ) | const

virtual

Get the current size of the file.

Returns
  length of file in bytes.

Reimplemented in PMemoryFile.

virtual PString PFile::GetName | ( |  | ) | const

virtual

Get the platform and I/O channel type name of the channel.

For example, it would return the filename in `PFile` type channels.

Returns
  the name of the channel.

Reimplemented from PChannel.

virtual off_t PFile::GetPosition | ( |  | ) | const

virtual

Get the current active position in the file for the next read or write operation.

Returns
  current file position relative to start of file.

Reimplemented in PWAVFile, and PMemoryFile.

PBoolean PFile::IsEndOfFile | ( |  | ) | const

Determine if the current file position is at the end of the file.

If this is true then any read operation will fail.

Returns
  true if at end of file.

static PBoolean PFile::Move | ( | const PFilePath & | oldname,
|  | const PFilePath & | newname,
|  | PBoolean | force = `false`
| ) |  |

static

Move the specified file.

This will move the file from one position in the directory hierarchy to another position. The actual operation is platform dependent but the reslt is the same. For instance, for Unix, if the move is within a file system then a simple rename is done, if it is across file systems then a copy and a delete is performed.

Returns
  true if the file was moved.

Parameters

  oldname | Old path and name of the file.
  newname | New path and name for the file.
  force | Delete file if a destination exists with the same name.

PBoolean PFile::Move | ( | const PFilePath & | newname,
|  | PBoolean | force = `false`
| ) |  |

Move the current file.

This will move the file from one position in the directory hierarchy to another position. The actual operation is platform dependent but the reslt is the same. For instance, for Unix, if the move is within a file system then a simple rename is done, if it is across file systems then a copy and a delete is performed.

Returns
  true if the file was moved.

Parameters

  newname | New path and name for the file.
  force | Delete file if a destination exists with the same name.

virtual PBoolean PFile::Open | ( | OpenMode | mode = `ReadWrite`,
|  | int | opts = `ModeDefault`
| ) |  |

virtual

Open the current file in the specified mode and with the specified options.

If the file object already has an open file then it is closed.

If there has not been a filename attached to the file object (via `SetFilePath()`, the `name` parameter or a previous open) then a new unique temporary filename is generated.

Returns
  true if the file was successfully opened.

Reimplemented in PWAVFile, and PMemoryFile.

virtual PBoolean PFile::Open | ( | const PFilePath & | name,
|  | OpenMode | mode = `ReadWrite`,
|  | int | opts = `ModeDefault`
| ) |  |

virtual

Open the specified file name in the specified mode and with the specified options.

If the file object already has an open file then it is closed.

Note: if `mode` is StandardInput, StandardOutput or StandardError, then the `name` parameter is ignored.

Returns
  true if the file was successfully opened.

Reimplemented in PWAVFile, and PMemoryFile.

virtual PBoolean PFile::Read | ( | void * | buf,
|  | PINDEX | len
| ) |  |

virtual

Low level read from the file channel.

The read timeout is ignored for file I/O. The GetLastReadCount() function returns the actual number of bytes read.

The GetErrorCode() function should be consulted after Read() returns false to determine what caused the failure.

Returns
  true indicates that at least one character was read from the channel. false means no bytes were read due to timeout or some other I/O error.

Parameters

  buf | Pointer to a block of memory to receive the read bytes.
  len | Maximum number of bytes to read into the buffer.

Reimplemented from PChannel.

Reimplemented in PWAVFile, and PMemoryFile.

static PBoolean PFile::Remove | ( | const PFilePath & | name,
|  | PBoolean | force = `false`
| ) |  |

static

Delete the specified file.

If `force` is false and the file is protected against being deleted then the function fails. If `force` is true then the protection is ignored. What constitutes file deletion protection is platform dependent, eg on DOS is the Read Only attribute and on a Novell network it is a Delete trustee right. Some protection may not be able to overridden with the `force` parameter at all, eg on a Unix system and you are not the owner of the file.

Returns
  true if the file was deleted.

static PBoolean PFile::Remove | ( | const PString & | name,
|  | PBoolean | force = `false`
| ) |  |

static

PBoolean PFile::Remove | ( | PBoolean | force = `false` | ) |

Delete the current file.

If `force` is false and the file is protected against being deleted then the function fails. If `force` is true then the protection is ignored. What constitutes file deletion protection is platform dependent, eg on DOS is the Read Only attribute and on a Novell network it is a Delete trustee right. Some protection may not be able to overridden with the `force` parameter at all, eg on a Unix system and you are not the owner of the file.

Returns
  true if the file was deleted.

static PBoolean PFile::Rename | ( | const PFilePath & | oldname,
|  | const PString & | newname,
|  | PBoolean | force = `false`
| ) |  |

static

Change the specified files name.

This does not move the file in the directory hierarchy, it only changes the name of the directory entry.

The `newname` parameter must consist only of the file name part, as returned by the `PFilePath::GetFileName()` function. Any other file path parts will cause an error.

The first form uses the file path specification associated with the instance of the object. The name within the instance is changed to the new name if the function succeeds. The second static function uses an arbitrary file specified by name.

Returns
  true if the file was renamed.

Parameters

  oldname | Old name of the file.
  newname | New name for the file.
  force | Delete file if a destination exists with the same name.

PBoolean PFile::Rename | ( | const PString & | newname,
|  | PBoolean | force = `false`
| ) |  |

Change the current files name.

This does not move the file in the directory hierarchy, it only changes the name of the directory entry.

The `newname` parameter must consist only of the file name part, as returned by the `PFilePath::GetFileName()` function. Any other file path parts will cause an error.

The first form uses the file path specification associated with the instance of the object. The name within the instance is changed to the new name if the function succeeds. The second static function uses an arbitrary file specified by name.

Returns
  true if the file was renamed.

Parameters

  newname | New name for the file.
  force | Delete file if a destination exists with the same name.

void PFile::SetFilePath | ( | const PString & | path | ) |

Set the full path name of the file.

The `PFilePath` object describes the full file name specification for the particular platform.

Parameters

  path | New file path.

virtual PBoolean PFile::SetLength | ( | off_t | len | ) |

virtual

Set the size of the file, padding with 0 bytes if it would require expanding the file, or truncating it if being made shorter.

Returns
  true if the file size was changed to the length specified.

Reimplemented in PMemoryFile.

static PBoolean PFile::SetPermissions | ( | const PFilePath & | name,
|  | int | permissions
| ) |  |

static

Set permissions on the specified file.

Returns
  true if the file was renamed.

PBoolean PFile::SetPermissions | ( | int | permissions | ) |

Set permissions on the current file.

Returns
  true if the file was renamed.

virtual PBoolean PFile::SetPosition | ( | off_t | pos,
|  | FilePositionOrigin | origin = `Start`
| ) |  |

virtual

Set the current active position in the file for the next read or write operation.

The `pos` variable is a signed number which is added to the specified origin. For `origin == PFile::Start` only positive values for `pos` are meaningful. For `origin == PFile::End` only negative values for `pos` are meaningful.

Returns
  true if the new file position was set.

Parameters

  pos | New position to set.
  origin | Origin for position change.

Reimplemented in PWAVFile, and PMemoryFile.

virtual PBoolean PFile::Write | ( | const void * | buf,
|  | PINDEX | len
| ) |  |

virtual

Low level write to the file channel.

The write timeout is ignored for file I/O. The GetLastWriteCount() function returns the actual number of bytes written.

The GetErrorCode() function should be consulted after Write() returns false to determine what caused the failure.

Returns
  true if at least len bytes were written to the channel.

Parameters

  buf | Pointer to a block of memory to write.
  len | Number of bytes to write.

Reimplemented from PChannel.

Reimplemented in PWAVFile, and PMemoryFile.

## Member Data Documentation

PFilePath PFile::path

protected

The fully qualified path name for the file.

PBoolean PFile::removeOnClose

protected

File is to be removed when closed.

The documentation for this class was generated from the following file:

- file.h